/*
 * Card.java
 *
 * Created on 25. Mai 2007, 19:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.*;
import java.awt.geom.*;
/**
 *
 * @author Sunshine
 */
public class CardEx extends Card {
    
    public static final int IMAGESIZE = 120;
    
    private Image   image;                          // image of this card
    private int     x = 0, y = 0;                   // current position on applet
    public int      xOriginal = 0, yOriginal = 0;   // original position on applet on startup
    public int      gridBlockX = -1, gridBlockY = -1;  // the block on the grid where card lies; only valid when already placed
    
    /** Creates a new instance of Card */
    public CardEx() { }
    public CardEx(int x, int y) {
        this.x = x;
        this.y = y;
        this.xOriginal = x;
        this.yOriginal = y;
    }
    
    public CardEx(int x, int y, byte top, byte right, byte bottom, byte left)
    {
        super(top, right, bottom, left);
        this.x = x;
        this.y = y;
        this.xOriginal = x;
        this.yOriginal = y;
    }
    
    public void setImage(Image image)
    {
        this.image = image;
    }

    public void draw(Graphics2D g) {
        if (this.rotationPos == 0)
        {
            // draw image normal
            g.drawImage(image, x, y, null);
        }
        else
        {
            // draw rotated
            AffineTransform origTransform = g.getTransform();
            AffineTransform newTransform = (AffineTransform)(origTransform.clone());
            //center of rotation is center of the image
            int xRot = this.x + CardEx.IMAGESIZE / 2;
            int yRot = this.y + CardEx.IMAGESIZE / 2;
            newTransform.rotate(Math.toRadians(this.rotationPos), xRot, yRot);
            g.setTransform(newTransform);
            //draw image centered in panel
            g.drawImage(this.image, this.x, this.y, null);
            g.setTransform(origTransform);
        }
    }
    
    public boolean isPointInside(Point p)
    {
        return ( (p.x >= x && p.y >= y && p.x <= (x + IMAGESIZE) && p.y <= (y + IMAGESIZE)));
    }
    
    public void setPos(int xpos, int ypos)
    {
        x = xpos;
        y = ypos;
    }
    
    public void setPos(Point p)
    {
        x = p.x;
        y = p.y;
    }
    
    public int xOffsetToCorner(Point p)
    {
        return p.x - x;
    }
    
    public int yOffsetToCorner(Point p)
    {
        return p.y - y;
    }

    public int getY() {
        return y;
    }

    public int getX() {
        return x;
    }
    
    
    
}
